//*****************************************************************************
// Description     : Declaration of functions and structure for controlling device
// Target Device   : APV8016A
// Target Platform : Linux, C
// Date            : Nov. 2020
// Version         : 1.0
//*****************************************************************************
#ifndef __DEVICE_H__
#define __DEVICE_H__

#include "sys_compatible.h"
#include "sitcp.h"
#include "command.h"


// Number of CH
#define DEVICE_MAX_CHNUM	(0x0010)

// Number of histogram data per CH
#define NUM_DATA	(16384)

//********** macro function *******************
#define DEVICE_CNT_PER_NSEC		(10)	// 1count = 10nsec
// convert msec to count
#define device_msec2count(msec) \
            (((unsigned qword)(msec) * 1000000UL) / (unsigned qword)(DEVICE_CNT_PER_NSEC))
// convert count to msec
#define device_count2msec(count) \
            (((unsigned qword)(count) * (unsigned qword)(DEVICE_CNT_PER_NSEC)) / 1000000UL)


//********** prototype declaration **********
extern int device_read_status(int, int,
								unsigned short *, unsigned qword *,
								unsigned int *, unsigned int *);
extern int device_read_histogram(int, int, char*, int, int);


#endif // __DEVICE_H__
